diff --git a/pki/base/common/src/com/netscape/cmscore/cert/CertUtils.java b/pki/base/common/src/com/netscape/cmscore/cert/CertUtils.java
index 5a49d06e80f584b65af92fc5aa07040fef228ed7..97db7921701dcf16cc19c9bc07902d16436e50a8 100644
--- a/pki/base/common/src/com/netscape/cmscore/cert/CertUtils.java
+++ b/pki/base/common/src/com/netscape/cmscore/cert/CertUtils.java
@@ -473,7 +473,7 @@ public class CertUtils {
 
             if (extns != null) {
                 NSCertTypeExtension nsExtn = (NSCertTypeExtension)
-                    extns.get(NSCertTypeExtension.NAME);
+                    extns.get(NSCertTypeExtension.class.getSimpleName());
 
                 if (nsExtn != null) {
                     String nsType = getNSExtensionInfo(nsExtn);
diff --git a/pki/base/common/src/com/netscape/cmscore/cert/CrlCachePrettyPrint.java b/pki/base/common/src/com/netscape/cmscore/cert/CrlCachePrettyPrint.java
index 232035250e637356f0da96157ea4fae59db8765f..5c3c80012b012f1f49c2ebc6a144855390e124f4 100644
--- a/pki/base/common/src/com/netscape/cmscore/cert/CrlCachePrettyPrint.java
+++ b/pki/base/common/src/com/netscape/cmscore/cert/CrlCachePrettyPrint.java
@@ -27,7 +27,7 @@ import java.util.TimeZone;
 
 import netscape.security.x509.CRLExtensions;
 import netscape.security.x509.Extension;
-import netscape.security.x509.RevokedCertImpl;
+import netscape.security.x509.RevokedCertificate;
 
 import com.netscape.certsrv.apps.CMS;
 import com.netscape.certsrv.base.ICRLPrettyPrint;
@@ -183,14 +183,14 @@ public class CrlCachePrettyPrint implements ICRLPrettyPrint
                 }
                 sb.append("\n");
 
-                Set revokedCerts = mIP.getRevokedCertificates((int)(pageStart-1), (int)upperLimit);
+                Set<RevokedCertificate> revokedCerts = mIP.getRevokedCertificates((int)(pageStart-1), (int)upperLimit);
 
                 if (revokedCerts != null) {
-                    Iterator i = revokedCerts.iterator();
+                    Iterator<RevokedCertificate> i = revokedCerts.iterator();
                     long l = 1;
 
                     while ((i.hasNext()) && ((crlSize == 0) || (upperLimit - pageStart + 1 >= l))) {
-                        RevokedCertImpl revokedCert = (RevokedCertImpl)i.next();
+                        RevokedCertificate revokedCert = i.next();
 
                         if ((crlSize == 0) || (upperLimit - pageStart + 1 >= l)) {
                             sb.append(pp.indent(16) + resource.getString(
diff --git a/pki/base/common/src/com/netscape/cmscore/cert/OidLoaderSubsystem.java b/pki/base/common/src/com/netscape/cmscore/cert/OidLoaderSubsystem.java
index b340ea2368096ef085aff1c8696a338ab41adde0..9353ae8ff0d130dd3f1c39d23c5ee96b7323bd0e 100644
--- a/pki/base/common/src/com/netscape/cmscore/cert/OidLoaderSubsystem.java
+++ b/pki/base/common/src/com/netscape/cmscore/cert/OidLoaderSubsystem.java
@@ -89,28 +89,28 @@ public class OidLoaderSubsystem implements ISubsystem {
     private static final String[][] oidMapEntries = new String[][] {
             {NSCertTypeExtension.class.getName(),
                 CertType_Id.toString(),
-                NSCertTypeExtension.NAME},
+                NSCertTypeExtension.class.getSimpleName()},
             {CertificateRenewalWindowExtension.class.getName(),
                 CertificateRenewalWindowExtension.ID.toString(),
-                CertificateRenewalWindowExtension.NAME},
+                CertificateRenewalWindowExtension.class.getSimpleName()},
             {CertificateScopeOfUseExtension.class.getName(),
                 CertificateScopeOfUseExtension.ID.toString(),
                 CertificateScopeOfUseExtension.NAME},
             {DeltaCRLIndicatorExtension.class.getName(),
                 DeltaCRLIndicatorExtension.OID,
-                DeltaCRLIndicatorExtension.NAME},
+                DeltaCRLIndicatorExtension.class.getSimpleName()},
             {HoldInstructionExtension.class.getName(),
                 HoldInstructionExtension.OID,
-                HoldInstructionExtension.NAME},
+                HoldInstructionExtension.class.getSimpleName()},
             {InvalidityDateExtension.class.getName(),
                 InvalidityDateExtension.OID,
-                InvalidityDateExtension.NAME},
+                InvalidityDateExtension.class.getSimpleName()},
             {IssuingDistributionPointExtension.class.getName(),
                 IssuingDistributionPointExtension.OID,
-                IssuingDistributionPointExtension.NAME},
+                IssuingDistributionPointExtension.class.getSimpleName()},
             {FreshestCRLExtension.class.getName(),
                 FreshestCRLExtension.OID,
-                FreshestCRLExtension.NAME},
+                FreshestCRLExtension.class.getSimpleName()},
         };
 
     /**
@@ -137,7 +137,7 @@ public class OidLoaderSubsystem implements ISubsystem {
         }
         mConfig = config;
 
-        Enumeration names = mConfig.getSubStoreNames();
+        Enumeration<String> names = mConfig.getSubStoreNames();
 
         // load static (build-in) extensions
 
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/RevocationInfoMapper.java b/pki/base/common/src/com/netscape/cmscore/dbs/RevocationInfoMapper.java
index fc0eb3866737463cdbe39b91b7ff6a9b9d18539d..c0949f6663e288e859b5cd3012c600979ca8a342 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/RevocationInfoMapper.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/RevocationInfoMapper.java
@@ -48,7 +48,7 @@ import com.netscape.cmscore.util.Debug;
  */
 public class RevocationInfoMapper implements IDBAttrMapper {
 
-    protected static Vector mNames = new Vector();
+    protected static Vector<String> mNames = new Vector<String>();
     static {
         mNames.addElement(CertDBSchema.LDAP_ATTR_REVO_INFO);
     }
@@ -59,7 +59,7 @@ public class RevocationInfoMapper implements IDBAttrMapper {
     public RevocationInfoMapper() {
     }
 
-    public Enumeration getSupportedLDAPAttributeNames() {
+    public Enumeration<String> getSupportedLDAPAttributeNames() {
         return mNames.elements();
     }
 
@@ -76,10 +76,10 @@ public class RevocationInfoMapper implements IDBAttrMapper {
             CRLExtensions exts = info.getCRLEntryExtensions();
             // CRLExtension's DER encoding and decoding does not work!
             // That is why we need to do our own serialization.
-            Enumeration e = exts.getElements();
+            Enumeration<Extension> e = exts.getElements();
 
             while (e.hasMoreElements()) {
-                Extension ext = (Extension) e.nextElement();
+                Extension ext = e.nextElement();
 
                 if (ext instanceof CRLReasonExtension) {
                     RevocationReason reason = 
@@ -143,14 +143,14 @@ public class RevocationInfoMapper implements IDBAttrMapper {
                                 Integer.parseInt(reasonStr));
                         CRLReasonExtension ext = new CRLReasonExtension(reason);
 
-                        exts.set(CRLReasonExtension.NAME, ext);
+                        exts.set(CRLReasonExtension.class.getSimpleName(), ext);
                     } else if (str.startsWith("InvalidityDateExtension=")) {
                         String invalidityDateStr = str.substring(24);
                         Date invalidityDate = DateMapper.dateFromDB(invalidityDateStr);
                         InvalidityDateExtension ext =
                             new InvalidityDateExtension(invalidityDate);
 
-                        exts.set(InvalidityDateExtension.NAME, ext);
+                        exts.set(InvalidityDateExtension.class.getSimpleName(), ext);
                     } else {
                         Debug.trace("XXX skipped extension");
                     }
diff --git a/pki/base/common/src/com/netscape/cmscore/dbs/X509CertImplMapper.java b/pki/base/common/src/com/netscape/cmscore/dbs/X509CertImplMapper.java
index e1aa144b91923ff86d3d4b3d6a431758ae9a1ab5..9acf05f2014f8746a518a9d5c5b544d5a879362f 100644
--- a/pki/base/common/src/com/netscape/cmscore/dbs/X509CertImplMapper.java
+++ b/pki/base/common/src/com/netscape/cmscore/dbs/X509CertImplMapper.java
@@ -56,8 +56,8 @@ public class X509CertImplMapper implements IDBAttrMapper {
     public X509CertImplMapper() {
     }
 
-    public Enumeration getSupportedLDAPAttributeNames() {
-        Vector v = new Vector();
+    public Enumeration<String> getSupportedLDAPAttributeNames() {
+        Vector<String> v = new Vector<String>();
 
         v.addElement(CertDBSchema.LDAP_ATTR_NOT_BEFORE);
         v.addElement(CertDBSchema.LDAP_ATTR_NOT_AFTER);
@@ -92,11 +92,11 @@ public class X509CertImplMapper implements IDBAttrMapper {
                     cert.getSubjectDN().getName()));
             attrs.add(new LDAPAttribute(CertDBSchema.LDAP_ATTR_PUBLIC_KEY_DATA, cert.getPublicKey().getEncoded()));
             // make extension searchable
-            Set nonCritSet = cert.getNonCriticalExtensionOIDs();
+            Set<String> nonCritSet = cert.getNonCriticalExtensionOIDs();
 
             if (nonCritSet != null) {
-                for (Iterator i = nonCritSet.iterator(); i.hasNext();) {
-                    String oid = (String) i.next();
+                for (Iterator<String> i = nonCritSet.iterator(); i.hasNext();) {
+                    String oid = i.next();
 
                     if (oid.equals("2.16.840.1.113730.1.1")) {
                         String extVal = getCertTypeExtensionInfo(cert);
@@ -115,11 +115,11 @@ public class X509CertImplMapper implements IDBAttrMapper {
                             CertDBSchema.LDAP_ATTR_EXTENSION, oid));
                 }
             }
-            Set critSet = cert.getCriticalExtensionOIDs();
+            Set<String> critSet = cert.getCriticalExtensionOIDs();
 
             if (critSet != null) {
-                for (Iterator i = critSet.iterator(); i.hasNext();) {
-                    String oid = (String) i.next();
+                for (Iterator<String> i = critSet.iterator(); i.hasNext();) {
+                    String oid =  i.next();
 
                     if (oid.equals("2.16.840.1.113730.1.1")) {
                         String extVal = getCertTypeExtensionInfo(cert);
@@ -172,7 +172,7 @@ public class X509CertImplMapper implements IDBAttrMapper {
             if (ext == null) {
                 // sometime time (during installation) it
                 // is named differently
-                ext = cert.getExtension(NSCertTypeExtension.NAME);
+                ext = cert.getExtension(NSCertTypeExtension.class.getSimpleName());
                 if (ext == null)
                     return null;
             }
@@ -218,7 +218,7 @@ public class X509CertImplMapper implements IDBAttrMapper {
             if (ext == null) {
                 // sometime time (during installation) it
                 // is named differently
-                ext = cert.getExtension(BasicConstraintsExtension.NAME);
+                ext = cert.getExtension(BasicConstraintsExtension.class.getSimpleName());
                 if (ext == null)
                     return null;
             }
diff --git a/pki/base/common/src/com/netscape/cmscore/extensions/CMSExtensionsMap.java b/pki/base/common/src/com/netscape/cmscore/extensions/CMSExtensionsMap.java
index a5eb391d886d4212816f301bcb485199e1192f0a..b0fe0432c310173a080c579e974b0dc790eb8905 100644
--- a/pki/base/common/src/com/netscape/cmscore/extensions/CMSExtensionsMap.java
+++ b/pki/base/common/src/com/netscape/cmscore/extensions/CMSExtensionsMap.java
@@ -49,8 +49,8 @@ public class CMSExtensionsMap implements ISubsystem {
 
     private static final String PROP_CLASS = "class";
 
-    private Hashtable mName2Ext = new Hashtable();
-    private Hashtable mOID2Ext = new Hashtable();
+    private Hashtable<String, ICMSExtension> mName2Ext = new Hashtable<String, ICMSExtension>();
+    private Hashtable<String, ICMSExtension> mOID2Ext = new Hashtable<String, ICMSExtension>();
     private ISubsystem mOwner = null;
     private IConfigStore mConfig = null;
 
@@ -63,7 +63,7 @@ public class CMSExtensionsMap implements ISubsystem {
         mOwner = owner;
         mConfig = config;
 
-        Enumeration sstores = mConfig.getSubStoreNames();
+        Enumeration<String> sstores = mConfig.getSubStoreNames();
 
         while (sstores.hasMoreElements()) {
             String name = (String) sstores.nextElement();
diff --git a/pki/base/common/src/com/netscape/cmscore/notification/ReqCertSANameEmailResolver.java b/pki/base/common/src/com/netscape/cmscore/notification/ReqCertSANameEmailResolver.java
index b592ea168fa21928c90f8db96b13aebbf104a78c..580c9e98875f35b079d9be7cc7ee27f0237ac39f 100644
--- a/pki/base/common/src/com/netscape/cmscore/notification/ReqCertSANameEmailResolver.java
+++ b/pki/base/common/src/com/netscape/cmscore/notification/ReqCertSANameEmailResolver.java
@@ -25,7 +25,6 @@ import java.security.cert.X509Certificate;
 import java.util.Enumeration;
 
 import netscape.security.x509.CertificateExtensions;
-import netscape.security.x509.GeneralName;
 import netscape.security.x509.GeneralNameInterface;
 import netscape.security.x509.GeneralNames;
 import netscape.security.x509.RevokedCertImpl;
@@ -172,7 +171,7 @@ public class ReqCertSANameEmailResolver implements IEmailResolver {
                     try {
                         ext = 
                                 (SubjectAlternativeNameExtension)
-                                exts.get(SubjectAlternativeNameExtension.NAME);
+                                exts.get(SubjectAlternativeNameExtension.class.getSimpleName());
                     } catch (IOException e) {
                         log(ILogger.LL_FAILURE,
                             CMS.getLogMessage("CMSCORE_NOTIFY_GET_EXT", e.toString()));
@@ -187,19 +186,16 @@ public class ReqCertSANameEmailResolver implements IEmailResolver {
                             GeneralNames gn =
                                 (GeneralNames) ext.get(SubjectAlternativeNameExtension.SUBJECT_NAME);
 
-                            Enumeration e = gn.elements();
+                            Enumeration<GeneralNameInterface> e = gn.elements();
 
                             while (e.hasMoreElements()) {
-                                Object g = (Object) e.nextElement();
-
-                                GeneralName gni =
-                                    (GeneralName) g;
+                                GeneralNameInterface gni =e.nextElement();
 
                                 if (gni.getType() ==
                                     GeneralNameInterface.NAME_RFC822) {
                                     CMS.debug("got an subjectalternatename email");
 
-                                    String nameString = g.toString();
+                                    String nameString = gni.toString();
 
                                     // "RFC822Name: " + name
                                     mEmail =
diff --git a/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java b/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java
index 2da14467ecb746b7f3cd17d7c2947b6ed7a1896f..47418664d2938adc7a6b7ee30dc58007addeceae 100644
--- a/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java
+++ b/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java
@@ -31,6 +31,7 @@ import java.util.Enumeration;
 import java.util.Hashtable;
 import java.util.Iterator;
 import java.util.Locale;
+import java.util.Map;
 import java.util.Set;
 import java.util.Vector;
 
@@ -178,7 +179,7 @@ public abstract class ARequestQueue
      * @return
      *    an Enumeration that generates RequestId objects.
      */
-    abstract protected Enumeration getRawList();
+    abstract protected Enumeration<RequestId> getRawList();
 
     /**
      * protected access for setting the current state of a request.
@@ -429,7 +430,7 @@ public abstract class ARequestQueue
         if (agentName == null) throw new EBaseException("Missing agent information");
 
         aas.addApproval(agentName);
-        r.setExtData(AgentApprovals.class.getName(), aas.toStringVector());
+        r.setExtData(AgentApprovals.class.getName(), (Vector<?>)aas.toStringVector());
 
         PolicyResult pr = mPolicy.apply(r);
 
@@ -830,7 +831,7 @@ class Request
      * this isn't that efficient but will do for now.
      */
     public void copyContents(IRequest req) {
-        Enumeration e = req.getExtDataKeys();
+        Enumeration<String> e = req.getExtDataKeys();
         while (e.hasMoreElements()) {
             String key = (String) e.nextElement();
             if (!key.equals(IRequest.ISSUED_CERTS) &&
@@ -858,18 +859,20 @@ class Request
                (! key.equals(""));
     }
 
-    protected boolean isValidExtDataHashtableValue(Hashtable hash) {
+    protected boolean isValidExtDataHashtableValue(Hashtable<String, Object> hash) {
         if (hash == null) {
             return false;
         }
-        Enumeration keys = hash.keys();
+        Enumeration<String> keys = hash.keys();
         while (keys.hasMoreElements()) {
             Object key = keys.nextElement();
             if (! ((key instanceof String) &&
                     isValidExtDataKey((String)key)) ) {
                 return false;
             }
-
+            /*
+             * 	TODO  should the Value type be String?
+             */
             Object value = hash.get(key);
             if (! (value instanceof String)) {
                 return false;
@@ -891,12 +894,13 @@ class Request
         return true;
     }
 
-    public boolean setExtData(String key, Hashtable value) {
-        if ( !(isValidExtDataKey(key) && isValidExtDataHashtableValue(value)) ) {
+    @SuppressWarnings("unchecked")
+	public boolean setExtData(String key, Hashtable<String, ?> value) {
+        if ( !(isValidExtDataKey(key) && isValidExtDataHashtableValue((Hashtable<String, Object>) value)) ) {
             return false;
         }
 
-        mExtData.put(key, new ExtDataHashtable(value));
+        mExtData.put(key, new ExtDataHashtable<Object>(value));
         return true;
     }
 
@@ -915,7 +919,8 @@ class Request
         return (String)value;
     }
 
-    public Hashtable getExtDataInHashtable(String key) {
+    @SuppressWarnings("unchecked")
+	public <V> Hashtable<String, V> getExtDataInHashtable(String key) {
         Object value = mExtData.get(key);
         if (value == null) {
             return null;
@@ -923,10 +928,10 @@ class Request
         if (! (value instanceof Hashtable)) {
             return null;
         }
-        return new ExtDataHashtable((Hashtable)value);
+        return new ExtDataHashtable<V>((Map<? extends String, ? extends V>)value);
     }
 
-    public Enumeration getExtDataKeys() {
+    public Enumeration<String> getExtDataKeys() {
         return mExtData.keys();
     }
 
@@ -945,9 +950,10 @@ class Request
             return false;
         }
 
-        Hashtable existingValue = (Hashtable)mExtData.get(key);
+        @SuppressWarnings("unchecked")
+		Hashtable<String, String> existingValue = (Hashtable<String, String>)mExtData.get(key);
         if (existingValue == null) {
-            existingValue = new ExtDataHashtable();
+            existingValue = new ExtDataHashtable<String>();
             mExtData.put(key, existingValue);
         }
         existingValue.put(subkey, value);
@@ -955,7 +961,7 @@ class Request
     }
 
     public String getExtDataInString(String key, String subkey) {
-        Hashtable value = getExtDataInHashtable(key);
+        Hashtable<String, Object> value = getExtDataInHashtable(key);
         if (value == null) {
             return null;
         }
@@ -1217,7 +1223,7 @@ class Request
         return certArray;
     }
 
-    public boolean setExtData(String key, Vector stringVector) {
+    public boolean setExtData(String key, Vector<?> stringVector) {
         String[] stringArray;
         if (stringVector == null) {
             return false;
@@ -1230,12 +1236,12 @@ class Request
         return setExtData(key, stringArray);
     }
 
-    public Vector getExtDataInStringVector(String key) {
+    public Vector<String> getExtDataInStringVector(String key) {
         String[] stringArray = getExtDataInStringArray(key);
         if (stringArray == null) {
             return null;
         }
-        return new Vector(Arrays.asList(stringArray));
+        return new Vector<String>(Arrays.asList(stringArray));
     }
 
     public boolean getExtDataInBoolean(String key, boolean defVal) {
@@ -1256,8 +1262,8 @@ class Request
         if (data == null) {
             return false;
         }
-        Hashtable hash = new Hashtable();
-        Enumeration keys = data.getElements();
+        Hashtable<String, String> hash = new Hashtable<String, String>();
+        Enumeration<String> keys = data.getElements();
         while (keys.hasMoreElements()) {
             try {
                 String authKey = (String) keys.nextElement();
@@ -1270,12 +1276,12 @@ class Request
     }
 
     public IAuthToken getExtDataInAuthToken(String key) {
-        Hashtable hash = getExtDataInHashtable(key);
+        Hashtable<String, Object> hash = getExtDataInHashtable(key);
         if (hash == null) {
             return null;
         }
         AuthToken authToken = new AuthToken(null);
-        Enumeration keys = hash.keys();
+        Enumeration<String> keys = hash.keys();
         while (keys.hasMoreElements()) {
             try {
                 String hashKey = (String) keys.nextElement();
@@ -1351,7 +1357,7 @@ class Request
         if (values == null) {
             return false;
         }
-        Hashtable hashValue = new Hashtable();
+        Hashtable<String, String> hashValue = new Hashtable<String, String>();
         for (int index = 0; index < values.length; index++) {
             hashValue.put(Integer.toString(index), values[index]);
         }
@@ -1361,7 +1367,7 @@ class Request
     public String[] getExtDataInStringArray(String key) {
         int index;
 
-        Hashtable hashValue = getExtDataInHashtable(key);
+        Hashtable<String, Object> hashValue = getExtDataInHashtable(key);
         if (hashValue == null) {
             String s = getExtDataInString(key);
             if (s == null) {
@@ -1371,10 +1377,10 @@ class Request
                 return sa;
             }
         }
-        Set arrayKeys = hashValue.keySet();
-        Vector listValue = new Vector(arrayKeys.size());
-        for (Iterator iter = arrayKeys.iterator(); iter.hasNext();) {
-            String arrayKey = (String)iter.next();
+        Set<String> arrayKeys = hashValue.keySet();
+        Vector<Object> listValue = new Vector<Object>(arrayKeys.size());
+        for (Iterator<String> iter = arrayKeys.iterator(); iter.hasNext();) {
+            String arrayKey = iter.next();
             try {
                 index = Integer.parseInt(arrayKey);
             } catch (NumberFormatException e) {
@@ -1406,7 +1412,7 @@ class Request
     protected String mOwner;
     protected String mRequestType;
     protected String mContext; // string for now.
-    protected ExtDataHashtable mExtData = new ExtDataHashtable();
+    protected ExtDataHashtable<Object> mExtData = new ExtDataHashtable<Object>();
 
     Date mCreationTime = CMS.getCurrentDate();
     Date mModificationTime = CMS.getCurrentDate();
@@ -1439,7 +1445,7 @@ class RequestIAttrSetWrapper implements IAttrSet {
         mRequest.deleteExtData(name);
     }
 
-    public Enumeration getElements() {
+    public Enumeration<String> getElements() {
         return mRequest.getExtDataKeys();
     }
 }
@@ -1471,7 +1477,7 @@ class RequestListByStatus
         return null;
     }
 
-    public Object nextElement() {
+    public RequestId nextElement() {
         RequestId next = mNext;
 
         update();
@@ -1487,7 +1493,7 @@ class RequestListByStatus
         return next;
     }
 
-    public RequestListByStatus(Enumeration e, RequestStatus s, IRequestQueue q) {
+    public RequestListByStatus(Enumeration<RequestId> e, RequestStatus s, IRequestQueue q) {
         mEnumeration = e;
         mStatus = s;
         mQueue = q;
@@ -1503,7 +1509,7 @@ class RequestListByStatus
         while (mNext == null) {
             if (!mEnumeration.hasMoreElements()) break;
    
-            rId = (RequestId) mEnumeration.nextElement();
+            rId =  mEnumeration.nextElement();
 
             try {
                 IRequest r = mQueue.findRequest(rId);
@@ -1518,7 +1524,7 @@ class RequestListByStatus
 
     protected RequestStatus mStatus;
     protected IRequestQueue mQueue;
-    protected Enumeration mEnumeration; 
+    protected Enumeration<RequestId> mEnumeration; 
     protected RequestId mNext;
 }
 
@@ -1529,7 +1535,7 @@ class RequestList
         return mEnumeration.hasMoreElements();
     }
 
-    public Object nextElement() {
+    public RequestId nextElement() {
         return mEnumeration.nextElement();
     }
 
@@ -1545,11 +1551,11 @@ class RequestList
         return null;
     }
 
-    public RequestList(Enumeration e) {
+    public RequestList(Enumeration<RequestId> e) {
         mEnumeration = e;
     }
 
-    protected Enumeration mEnumeration; 
+    protected Enumeration<RequestId> mEnumeration; 
 }
 
 
diff --git a/pki/base/common/src/com/netscape/cmscore/request/ExtDataHashtable.java b/pki/base/common/src/com/netscape/cmscore/request/ExtDataHashtable.java
index 415908dc315281319999bfaac6f53e4c54c81282..e3c1908e71bf07a3e2d5b33a0ec5640ab7b328a6 100644
--- a/pki/base/common/src/com/netscape/cmscore/request/ExtDataHashtable.java
+++ b/pki/base/common/src/com/netscape/cmscore/request/ExtDataHashtable.java
@@ -10,7 +10,7 @@ import java.util.Set;
  * purpose is to hide the fact that LDAP doesn't preserve the case of keys.
  * It does this by lowercasing all keys used to access the Hashtable.
  */
-public class ExtDataHashtable extends Hashtable {
+public class ExtDataHashtable<V> extends Hashtable<String, V> {
 
     /**
      *
@@ -29,7 +29,7 @@ public class ExtDataHashtable extends Hashtable {
         super(i, v);
     }
 
-    public ExtDataHashtable(Map map) {
+    public ExtDataHashtable(Map<? extends String, ? extends V> map) {
         // the super constructor seems to call putAll, but I can't
         // rely on that behaviour
         super();
@@ -44,7 +44,7 @@ public class ExtDataHashtable extends Hashtable {
         return super.containsKey(o);
     }
 
-    public Object get(Object o) {
+    public V get(Object o) {
         if (o instanceof String) {
             String key = (String)o;
             return super.get(key.toLowerCase());
@@ -52,7 +52,7 @@ public class ExtDataHashtable extends Hashtable {
         return super.get(o);
     }
 
-    public Object put(Object oKey, Object val) {
+    public V put(String oKey, V val) {
         if (oKey instanceof String) {
             String key = (String)oKey;
             return super.put(key.toLowerCase(), val);
@@ -60,16 +60,16 @@ public class ExtDataHashtable extends Hashtable {
         return super.put(oKey, val);
     }
 
-    public void putAll(Map map) {
-        Set keys = map.keySet();
-        for (Iterator i = keys.iterator();
+    public void putAll(Map<? extends String, ? extends V> map) {
+        Set<? extends String> keys = map.keySet();
+        for (Iterator<? extends String> i = keys.iterator();
              i.hasNext();) {
             Object key = i.next();
-            put(key, map.get(key));
+            put((String)key, map.get(key));
         }
     }
 
-    public Object remove(Object o) {
+    public V remove(Object o) {
         if (o instanceof String) {
             String key = (String)o;
             return super.remove(key.toLowerCase());
diff --git a/pki/base/common/src/com/netscape/cmscore/security/CertificateInfo.java b/pki/base/common/src/com/netscape/cmscore/security/CertificateInfo.java
index dc240dac2aeeaf2e922c62910527d7fab2d05a69..1b0c9f2fc3b3249c0f793c201375d0c1b6c4634c 100644
--- a/pki/base/common/src/com/netscape/cmscore/security/CertificateInfo.java
+++ b/pki/base/common/src/com/netscape/cmscore/security/CertificateInfo.java
@@ -262,7 +262,7 @@ public abstract class CertificateInfo {
 
         try {
             subjKeyExt =
-                    (SubjectKeyIdentifierExtension) caexts.get(SubjectKeyIdentifierExtension.NAME);
+                    (SubjectKeyIdentifierExtension) caexts.get(SubjectKeyIdentifierExtension.class.getSimpleName());
         } catch (IOException e) {
         }
 
@@ -274,7 +274,7 @@ public abstract class CertificateInfo {
             AuthorityKeyIdentifierExtension authExt =
                 new AuthorityKeyIdentifierExtension(false, keyId, null, null);
 
-            ext.set(AuthorityKeyIdentifierExtension.NAME, authExt);
+            ext.set(AuthorityKeyIdentifierExtension.class.getSimpleName(), authExt);
         }
     }
 }
